<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:ext="java:lu.bourse.api.deposant.action.xsl.XslManager"
	xmlns:ns="http://www.bourse.lu/rap/O41"
	xmlns:fnbourse="http://www.bcl.lu/2006/bcl-xpath-functions"
	version="2.0">

	<xsl:output method="xml" indent="yes" />
	
	<xsl:param name="spaceParam" />
	<xsl:param name="ficOri" />
	<xsl:param name="ligneOri" />

	<!-- Début Partie sur les Tests de Contrôles liées aux fichiers Déposés -->
	<!--  -->
	
	<xsl:template match="/ns:MsgInO41">
		<xsl:apply-templates select="ns:SeqInO41/ns:Conc1" />
	</xsl:template>
	
	<xsl:template match="ns:Conc1">
		<xsl:apply-templates select="ns:Context" />
		<xsl:apply-templates select="ns:Patrim" />
		<xsl:apply-templates select="ns:Actif/ns:ActifRapAnn41" />
	</xsl:template>
	
	<xsl:template match="ns:Context">
		<!-- Test CODE DEVISE -->
		<xsl:value-of
			select="ext:testCodDev($ficOri, $ligneOri, 'Code Devise', ns:Dev/ns:CdDevIso, $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
		
		<xsl:apply-templates select="ns:CollCompartRapO41" />
		
		<!-- Test TAUX CHANGE STRICT POSITIF -->
		<xsl:value-of
			select="ext:testPositifNegatifStrict($ficOri, $ligneOri, 'Taux de Change', format-number(ns:ContextRapAnn41/ns:TxChge * 100000, '######'), 'true', 'true', $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
	</xsl:template>
	
	<xsl:template match="ns:CollCompartRapO11">
		<!-- Test CODES CSSF (FONDS, COMPARTIMENTS) OBLIGATOIRES -->
		<xsl:value-of
			select="ext:testCodesObligatoires($ficOri, $ligneOri, ns:CdCssfOpc, ns:CdCssfCompart, $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
		
		<!-- Test DATE SUPERIEURE -->
		<xsl:value-of
			select="ext:testDateSuperieureStrict($ficOri, $ligneOri, 'Date de Fin de Période', ns:DtFinRap, 'Date de Début de Période', ns:DtDebRap, 'yyyy-MM-dd', $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
	</xsl:template>
	
	<xsl:template match="ns:Patrim">
		<!-- Test SOMMES DES VALEURS -->
		<xsl:value-of
			select="ext:testSommeValeurs($ficOri, $ligneOri, ns:L1112/ns:Mt, sum(ns:L1112/ns:S1112/ns:PaysEmisRap411112/ns:MtIml1112), ns:L1113/ns:Mt, sum(ns:L1113/ns:S1113/ns:PaysEmisRap411113/ns:MtIml1113), ns:L1114/ns:Mt, sum(ns:L1114/ns:S1114/ns:PaysEmisRap411114/ns:MtIml1114), ns:L1115/ns:Mt, sum(ns:L1115/ns:S1115/ns:PaysEmisRap411115/ns:MtIml1115), ns:L1121/ns:Mt, sum(ns:L1121/ns:S1121/ns:PaysEmisRap411121/ns:MtIml1121), ns:L1122/ns:Mt, sum(ns:L1122/ns:S1122/ns:PaysEmisRap411122/ns:MtIml1122), ns:L1130/ns:Mt, sum(ns:L1130/ns:S1130/ns:PaysEmisRap411130/ns:MtIml1130), ns:L1140/ns:Mt, sum(ns:L1140/ns:S1140/ns:PaysEmisRap411140/ns:MtIml1140), ns:L1320/ns:Mt, sum(ns:L1320/ns:S1320/ns:PaysEmisRap411320/ns:MtIml1320), ns:L1410/ns:Mt, sum(ns:L1410/ns:S1410/ns:PaysEmisRap411410/ns:MtIml1410), $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
		
		<xsl:value-of
			select="ext:testAdditionChampsO41($ficOri, $ligneOri, ns:Mt1000, ns:Mt1100, ns:Mt1110, ns:Mt1111, ns:L1112/ns:Mt, ns:L1113/ns:Mt, ns:L1114/ns:Mt, ns:L1115/ns:Mt, ns:Mt1120, ns:L1121/ns:Mt, ns:L1122/ns:Mt, ns:L1130/ns:Mt, ns:L1140/ns:Mt, ns:Mt1200, ns:Mt1210, ns:PatrimRapAnn41/ns:MtIml1211, ns:PatrimRapAnn41/ns:MtIml1212, ns:PatrimRapAnn41/ns:MtIml1220, ns:PatrimRapAnn41/ns:MtIml1230, ns:Mt1300, ns:Mt1310, ns:PatrimRapAnn41/ns:MtIml1311, ns:PatrimRapAnn41/ns:MtIml1312, ns:L1320/ns:Mt, ns:Mt1400, ns:L1410/ns:Mt, ns:PatrimRapAnn41/ns:MtIml1420, ns:Mt1500, ns:PatrimRapAnn41/ns:MtIml1510, ns:PatrimRapAnn41/ns:MtIml1520, ns:Mt2000, ns:PatrimRapAnn41/ns:MtIml2100, ns:PatrimRapAnn41/ns:MtIml2200, ns:Mt3000, ../ns:Ope/ns:Mt4000, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4100, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4200, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4300, ../ns:Ope/ns:Mt4400, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4410, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4420, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml4430, ../ns:Ope/ns:Mt5000, ../ns:Ope/ns:Mt5100, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5110, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5120, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5130, ../ns:Ope/ns:Mt5200, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5210, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5220, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5230, ../ns:Ope/ns:Mt5300, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5310, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5320, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5400, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml5500, ../ns:Ope/ns:Mt6000, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml7100, ../ns:Ope/ns:OpeRapAnn41/ns:MtIml7200, ../ns:Ope/ns:Mt7000, ../ns:Actif/ns:ActifRapAnn41/ns:MtIml3001, ../ns:Actif/ns:Mt7000, ../ns:Actif/ns:Mt8000, ../ns:Actif/ns:ActifRapAnn41/ns:MtIml8100, ../ns:Actif/ns:ActifRapAnn41/ns:MtIml8200, ../ns:Actif/ns:ActifRapAnn41/ns:MtIml9000, ../ns:Actif/ns:Mt3000, $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
	</xsl:template>
	
	<xsl:template match="ns:ActifRapAnn41">
		<!-- Test VALEUR EMISSIONS NETTES -->
		<xsl:value-of
			select="ext:testValeurSuperieure($ficOri, $ligneOri, 'Distributions', ns:MtIml9000, 'Dont Dividendes Reinvestis', ns:MtIml9100, 'false', $spaceParam)"
			xmlns:spaceParam="java:lu.bourse.services.workflow.Space" />
	</xsl:template>
	
	<!--  -->
	<!-- Fin Partie sur les Tests de Contrôles liés aux fichiers Déposés -->
	<!--  -->

</xsl:stylesheet>
